{
==========================================================
Acerte o Alvo  -  verso 2.0  -  1997

(c) Renato Degiovani

Este jogo foi desenvolvido para publicao na TILT online.
Todos os direitos reservados.
----------------------------------------------------------
}
unit Jog1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, MPlayer;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Area: TPaintBox;
    Alvo: TLabel;
    Novo: TSpeedButton;
    Dispara: TSpeedButton;
    Mensag: TLabel;
    Placar: TLabel;
    Tocar: TMediaPlayer;
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure NovoClick(Sender: TObject);
    procedure DisparaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

{===============================================================}
{--- Variveis Globais -----------------------------------------}
var
  Px,Py: integer;
  Status: byte;
  Contador: integer;
  Acertou: integer;

{--- Procedimentos de inicializao ----------------------------}
procedure Inicializa;
begin
   Px:= 10; Py:= 230; Status:= 0;
   Form1.Timer1.Enabled:= True;

   Form1.Area.Canvas.Pen.Color:= clSilver;
   Form1.Area.Canvas.Brush.Color:= clSilver;
   Form1.Area.Canvas.Rectangle(0,0,Form1.Area.Width,Form1.Area.Height);

   Form1.Area.Canvas.Pen.Color:= clBlack;
   Form1.Area.Canvas.Brush.Color:= clBlack;
   Form1.Area.Canvas.Rectangle(Px,Py,Px+4,Py+2);

   Form1.Alvo.Top:= 20 + Random(Form1.Area.Height - 40);
   Form1.Mensag.Caption:= 'Subindo...';
   inc(Contador);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   Randomize; Inicializa;
end;

{--- Looping principal do jogo ---------------------------------}
procedure TForm1.Timer1Timer(Sender: TObject);
begin
   if Status = 2 then begin
      Tocar.Filename:= 'errou.wav';
      if (Py < Alvo.Top-Area.Top+4) or (Py > Alvo.Top-Area.Top+8) then
         Mensag.Caption:= 'Errrroooouuuuu!!!!!!' else begin;
            Mensag.Caption:= 'Na mosca!';
            inc(Acertou);
            Tocar.Filename:= 'palmas.wav';
            end;
       Tocar.Open; Tocar.Play;
      Placar.Caption:= 'De '+IntToStr(Contador)+
         ' jogadas, acertou '+IntToStr(Acertou);
      Timer1.Enabled:= False; end;
   if Status = 0 then Py:= Py - 2;
   if Status = 1 then Px:= Px + 6;
   if Status <> 2 then begin
      Area.Canvas.Brush.Color:= clBlack;
      Area.Canvas.Rectangle(Px,Py,Px+6,Py+6); end;
   if Px > Area.Width - 8 then Status:= 2;
end;

{--- Novo jogo -------------------------------------------------}
procedure TForm1.NovoClick(Sender: TObject);
begin
   Inicializa;
end;

{--- Dispara no alvo -------------------------------------------}
procedure TForm1.DisparaClick(Sender: TObject);
begin
   Timer1.Interval:= 10; Status:= 1;
   Tocar.Filename:= 'dispara.wav';
   Tocar.Open; Tocar.Play;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
   Status:= 1; Timer1.Interval:= 10;
   Tocar.Filename:= 'dispara.wav';
   Tocar.Open; Tocar.Play;
end;

{---------------------------------------------------------------}
end.
